#!/bin/bash

#2022/01/18 v1.0 test
# Автор Мамзиков Артём Андреевич Описание по скрипту https://diyit.ru/viewtopic.php?t=1946

# Входные атрибуты для отправки информации об ошибке
# IP или DNS узла по умолчанию
HOSTCONN=$1
# Имя узла сети
HOSTHOST=$2
# Видимое имя
#HOSTNAME=$

#Входные данные для графиков:
# Имя
namegraph=$3



#***********************************************************************
#Начало пользовательских переменных
#Установите для них соответствующие значения перед выполнением сценария...
zabbixServer='127.0.0.1' # Или localhost 127.0.0.1
zabbixUsername='Admin' # Логин для заббикс
zabbixPassword='zabbix' #Пароль для заббикс
#Конец пользовательских переменных
#***********************************************************************

header='Content-Type:application/json-rpc'
zabbixApiUrl="http://$zabbixServer/zabbix/api_jsonrpc.php"

function exit_with_error() {
  echo '**********************************'
  echo "$errorMessage"
  echo '----------------------------------'
  echo 'Сформированная Команда выполнения'
  echo '----------------------------------'
  echo  curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl
  echo '----------------------------------'
  echo 'Выходные данные'
  echo '----------------------------------'
  echo "$result"
  echo '**********************************'
  zabbix_sender -z $zabbixServer -p 10051 -s "${HOSTCONN}" -k apitriggercreateerror -o "ERROR $errorMessage Команда выполнения: curl --silent --show-error --insecure --header $header --data $json $zabbixApiUrl Результат $result"
}


#------------------------------------------------------
# Аутентификация пользователя. https://www.zabbix.com/documentation/current/ru/manual/api/reference/user/login
#------------------------------------------------------
errorMessage='*ERROR* - Не удается получить токен авторизации Zabbix'
json=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.login\",\"params\":{\"user\": \"$zabbixUsername\",\"password\": \"$zabbixPassword\"},\"id\": 1 }`
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
auth=$(echo "${result}" |sed -e 's|.*result":"||' -e 's/","id.*//g')
check=$(echo "${auth}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&exit 1 ; fi
echo "Вход в систему выполнен успешно - Идентификатор авторизации: $auth"
errorMessage="";json="";result="";check="" # Очистка переменных


function outapi(){
#------------------------------------------------------
# Выход из zabbix https://www.zabbix.com/documentation/current/ru/manual/api/reference/user/logout
#------------------------------------------------------
# Выполнение выхода из API.
errorMessage='*ERROR* - Не удалось выйти из системы'
json=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.logout\",\"params\": [],\"id\": 1, \"auth\": \"$auth\"}`
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
logout=$(echo "${result}" |sed -e 's|.*result":||' -e 's/,"id.*//g')
check=$(echo "${logout}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error; fi
echo 'Успешно вышел из Zabbix' "${logout}"
errorMessage="";json="";result="";check="" # Очистка переменных
exit 1
}


# Запрос информации об авторизовавшемся пользователе
#usinfo=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.login\",\"params\":{\"user\": \"$zabbixUsername\",\"password\": \"$zabbixPassword\",\"userData\": true},\"id\": 1 }`
#infouser=`curl --silent --show-error --insecure --header $header --data "$usinfo" $zabbixApiUrl`
#echo "${infouser}"


#------------------------------------------------------
# Получение  графики  в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/graph/get
#------------------------------------------------------
errorMessage='*ERROR* - Не удается проверить график'
json="{\"jsonrpc\": \"2.0\",\"method\":\"graph.get\",\"params\": {\"output\": [\"graphids\",\"name\"],\"filter\": {\"host\": \"$HOSTHOST\",\"name\": \"$namegraph\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&outapi ; fi
# Поиск графика
checkgraphids=$(echo -e "${result}"|
egrep -i 'graphid":"[0-9]+"'|sed 's|.*result":||'|sed 's/,"id.*//g'|sed 's|.*name":"||'|sed 's/"}].*//g')
echo -e "Найденые графики:" "${result}"
#echo "Находим строку по соответствию" $checkgraphids
if [[ "$namegraph" == "$checkgraphids" ]]; then echo "График существует:" $namegraph &&outapi ; fi # Если график существует завершаем цикл скрипта
errorMessage="";json="";result="";check="" # Очистка переменных


#------------------------------------------------------
# Создание графика https://www.zabbix.com/documentation/current/ru/manual/api/reference/graph/create
#------------------------------------------------------
errorMessage='*ERROR* - Не удается создать график'
json="{\"jsonrpc\": \"2.0\",\"method\":\"graph.create\",\"params\":\
{\"name\": \"$namegraph\",\
\"width\": 900,\
\"height\": 200,\
\"graphtype\": 0,\
\"show_legend\": 1,\
\"show_work_period\": 1,\
\"show_triggers\": 1,\
\"percent_left\": 0,\
\"percent_right\": 0,\
\"yaxismin\": 0.0000,\
\"ymax_type\": 0,\
\"gitems\": [{\"itemid\": \"177041\",\"calc_fnc\": 7,\"drawtype \": 0,\"yaxisside\": 0,\"color\": \"00AA00\",\"sortorder\": \"0\"}]},\
\"auth\":\"$auth\", \"id\": 1 }"

result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
graphids=$(echo "${result}" |sed -e 's|.*result":{"graphids":\["||' -e 's/\"]},"id.*//g')
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&outapi ; fi
echo "Создание графика: $graphids"
errorMessage="";json="";result="";check="" # Очистка переменных

outapi # Запустим блок Выхода
