#!/bin/bash

#***********************************************************************
#Начало пользовательских переменных
#Установите для них соответствующие значения перед выполнением сценария...
zabbixServer='127.0.0.1' # Или localhost 127.0.0.1
zabbixUsername='Admin' # Логин для заббикс
zabbixPassword='zabbix' #Пароль для заббикс
#Конец пользовательских переменных
#***********************************************************************
# Объявим входные переменные(variable) и если входная переменная пустая задаем дефолтные настройки для некоторых переменных
IP=$1
# Имя узла сети
HOSTHOST=$2
# Видимое имя
HOSTNAME=$3
# Порт
PORT=${4:-10050}
# Имя ПО для поиска Элемента данных (по ключу)
PUT="${5:-root\OpenHardwareMonitor}"
# Фильтр Отобразить
FILTR=${6:-.*}
# Фильтр Скрыть
HIDE=${7:-^$}

# Получим текущий путь откуда запущен скрипт
#currentpath=$(readlink -f $0)
#currentpath="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)/$(basename "${BASH_SOURCE[0]}")"
currentpath="$( cd -- "$(dirname "$0")" >/dev/null 2>&1 ; pwd -P )"

TRS='\\'
# Проверка нескольких путей ПО на 1 хосте, делим через ;
IFS=';' read -ra sumdir < <(echo "${PUT}")
# Печать разделенной строки
for puti in "${sumdir[@]}"
do
# Для создания ключа нам надо название ПО
shopt -s nocasematch #shopt - приводим к одному регистру
if [[ ${puti} == *Open* ]]; then trput="root"${TRS}"OpenHardwareMonitor"
elif [[ ${puti} == *Libre* ]]; then trput="root"${TRS}"LibreHardwareMonitor"
elif [[ ${puti} == *HWM* ]]; then trput=Emkey="root"${TRS}"HMMonitor"
shopt -u nocasematch
else Emkey="${puti}"; fi
# Получаем Искомый ключ в узле
key="wmi.get["${trput}",SELECT Value FROM Sensor WHERE InstanceId="


header='Content-Type:application/json-rpc'
zabbixApiUrl="http://$zabbixServer/zabbix/api_jsonrpc.php"

function exit_with_error() {
  echo '**********************************'
  echo "$errorMessage"
  echo '----------------------------------'
  echo 'Сформированная Команда выполнения'
  echo '----------------------------------'
  echo  curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl
  echo '----------------------------------'
  echo 'Выходные данные'
  echo '----------------------------------'
  echo "$result"
  echo '**********************************'
  #zabbix_sender -z $zabbixServer -p 10051 -s "${HOSTCONN}" -k apitriggercreateerror -o "ERROR $errorMessage Команда выполнения: curl --silent --show-error --insecure --header $header --data $json $zabbixApiUrl Результат $result"
}


#------------------------------------------------------
# Аутентификация пользователя. https://www.zabbix.com/documentation/current/ru/manual/api/reference/user/login
#------------------------------------------------------
errorMessage='*ERROR* - Не удается получить токен авторизации Zabbix'
json=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.login\",\"params\":{\"user\": \"$zabbixUsername\",\"password\": \"$zabbixPassword\"},\"id\": 1 }`
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
auth=$(echo "${result}" |sed -e 's|.*result":"||' -e 's/","id.*//g')
check=$(echo "${auth}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&exit 1 ; fi
echo "Вход в систему выполнен успешно - Идентификатор авторизации: $auth"
errorMessage="";json="";result="";check="" # Очистка переменных


function outapi(){
#------------------------------------------------------
# Выход из zabbix https://www.zabbix.com/documentation/current/ru/manual/api/reference/user/logout
#------------------------------------------------------
# Выполнение выхода из API.
errorMessage='*ERROR* - Не удалось выйти из системы'
json=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.logout\",\"params\": [],\"id\": 1, \"auth\": \"$auth\"}`
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
logout=$(echo "${result}" |sed -e 's|.*result":||' -e 's/,"id.*//g')
check=$(echo "${logout}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error; fi
echo 'Успешно вышел из Zabbix' "${logout}"
errorMessage="";json="";result="";check="" # Очистка переменных
exit 1
}


# Запрос информации об авторизовавшемся пользователе
#usinfo=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.login\",\"params\":{\"user\": \"$zabbixUsername\",\"password\": \"$zabbixPassword\",\"userData\": true},\"id\": 1 }`
#infouser=`curl --silent --show-error --insecure --header $header --data "$usinfo" $zabbixApiUrl`
#echo "${infouser}"


#------------------------------------------------------
# Получение элементов в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/item/get
#------------------------------------------------------
errorMessage='*ERROR* - Не удается получить Элемент(ы) данных'
json="{\"jsonrpc\": \"2.0\",\"method\":\"item.get\",\"params\": {\"selectApplications\": [\"name\"],\"filter\": {\"status\": 0,\"type\": 0},\"host\": \""${HOSTHOST}"\",\"search\": {\"key_\": \"$key\"},\"output\": [\"key_\",\"units\",\"name\",\"applications\"]},\"auth\":\"$auth\", \"id\": 1 }"
#json="{\"jsonrpc\": \"2.0\",\"method\":\"item.get\",\"params\": {\"filter\": {\"status\": 0,\"type\": 0,\"units\": \"°C\"},\"host\": \""${HOSTHOST}"\",\"application\": \"OHM Temperature\",\"search\": {\"key_\": \"$key\",\"name\": \"CPU\",\"application\": \"Temperature\"},\"output\": [\"key_\"]},\"auth\":\"$auth\", \"id\": 1 }"
#json="{\"jsonrpc\": \"2.0\",\"method\":\"item.get\",\"params\": {\"filter\": {\"status\": 0,\"type\": 0,\"units\": \"°C\"},\"host\": \""${HOSTHOST}"\",\"application\": \"OHM Temperature\",\"search\": {\"key_\": \"wmi.get\",\"name\": \"CPU\",\"application\": \"Temperature\"},\"output\": [\"key_\"], \"selectApplications\": [\"name\"]},\"auth\":\"$auth\", \"id\": 1 }"
#json="{\"jsonrpc\": \"2.0\",\"method\":\"item.get\",\"params\": {\"output\": [\"key_\"], \"filter\": {\"status\": 0,\"type\": 0}, \"host\": \""${HOSTHOST}"\", \"group\": \"Сервера ЭСРН\"},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&outapi ; fi
# Элементы данных
PO=$(echo $trput|sed 's/.*\\//g')
item=$(echo -e $result|egrep -i 'itemid":"[0-9]+"'|sed 's|.*result":||'|sed 's/,"id.*//g'|sed 's/"itemid":"[0-9]\+","key_"://g'|sed 's/}]},{/\n/g'|sed 's/\[{"applicationid":"[0-9]\+","name":"'$PO'"},{"applicationid":"[0-9]\+","name"://g'|sed 's/^\[{\|}\]}\]$//g')
#echo "Найденые элементы данных:" $result
#echo "Ключи Элементов данных" "${item}"
FR=$FR"${item}"
errorMessage="";json="";result="";check="" # Очистка переменных

# Если не было зависимости от нет пинга к процессу проставим
namepo=$(echo Процесс $trput |sed 's|root\\\\||')
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "" "" "" "" "${namepo}" "NoPingAgent {HOST.NAME}"
#echo "Зависимость" "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "" "" "" "" "${namepo}" "NoPingAgent {HOST.NAME}"
#"${HOSTNAME}""

# Зависимость от процесса, для Нет Данных
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "" "" "" "" "Нет Данных HM-LLD-JSON-data" "${namepo}"

done

# Построчно
IFS=$'\n'
for element in $(echo "${FR}" 2>/dev/null);
do
#echo "${element}"
# Имя ПО для зависимости триггеров
namehw=$(echo Процесс $element |sed 's/"wmi.get\[root\\\|,SELECT.*//g')
#namehw=$(echo Процесс $namepo)
# Рассортируем по типам
case $element in
    *MHz*Clock*)
    keymhz=$(echo "${element}"|sed 's/^"\|","units".*//g'|sed 's/\\/\\\\/g')
    triggermhz="{"${HOSTHOST}":$keymhz"
    #echo $triggermhz
    ;;
    *%*Load*)
    keyload=$(echo "${element}"|sed 's/^"\|","units".*//g'|sed 's/\\/\\\\/g')
    triggerload="{"${HOSTHOST}":$keyload"
    ;;
    *%*Control*)
....
    ;;
    *°C*Temperature*CPU*)
    # Для Температуры CPU
    keytempcpu=$(echo "${element}"|grep -i "CPU"|sed 's/^"\|","units".*//g'|sed 's/\\/\\\\/g')
    triggertempcpu="{"${HOSTHOST}":$keytempcpu"
    #echo $triggertempcpu
....
    # Формируем триггеры:
    if [[ "$keytempcpu" != "" ]]; then
    extrtemptrigexpcpu=$extrtemptrigexpcpu"$ilitempcpu$triggertempcpu.avg(#3)}>70" # Условие: Для 70 градусов
    hightemptrigexpcpu=$hightemptrigexpcpu"$ilitempcpu$triggertempcpu.avg(#3)}>60" # Условие: Для 60 градусов
    ilitempcpu=' or\n'
    doptrigtempcpu="$triggertempcpu" # Для общего условия
    # Название Элемента в описание триггера (из каких эл-ов состоит триггер)
    destrigtempcpu=$destrigtempcpu$(echo "${element}"|grep -i "CPU"|sed 's/.*name":"\|","applications.*//g')\\n
    fi # присваиваем переменные если есть данные данного блока.
    keytempcpu=""
....
    ;;
    *°C*Temperature*)
    # Для Температуры Кроме CPU
    keytemp=$(echo "${element}"|grep -iv "CPU"|sed 's/^"\|","units".*//g'|sed 's/\\/\\\\/g')
    triggertemp="{"${HOSTHOST}":$keytemp"
    #echo $triggertemp
....
    # Формируем триггеры:
    if [[ "$keytemp" != "" ]]; then
    extrtemptrigexp=$extrtemptrigexp"$ilitemp$triggertemp.avg(#3)}>70" # Условие: Для 70 градусов
    hightemptrigexp=$hightemptrigexp"$ilitemp$triggertemp.avg(#3)}>60" # Условие: Для 60 градусов
    ilitemp=' or\n'
    doptrigtemp="$triggertemp" # Для общего условия
    # Название Элемента в описание триггера (из каких эл-ов состоит триггер)
    destrigtemp=$destrigtemp$(echo "${element}"|grep -iv "CPU"|sed 's/.*name":"\|","applications.*//g')\\n
    fi # присваиваем переменные если есть данные данного блока.
    keytemp=""
....
    ;;
    *GB*Data*)
....
    ;;
    *RPM*Fan*CPU*)
    # Кулера CPU
    keyfancpu=$(echo "${element}"|grep -i "CPU"|sed 's/^"\|","units".*//g'|sed 's/\\/\\\\/g')
    triggerfancpu="{"${HOSTHOST}":$keyfancpu"
    #echo $triggerfancpu
    if [[ "$keyfancpu" != "" ]]; then
    fantrigcpu=$fantrigcpu"$ilifancpu$triggerfancpu.avg(#3)}=0 or\n$triggerfancpu.avg(#3)}>2500" # Условие: Кулер неработает 0 или обороты выше 2500
    ilifancpu=' or\n'
    doptrigfancpu="$triggerfancpu" # Для общего условия
    # Название Элемента в описание триггера (из каких эл-ов состоит триггер)
    destrigfancpu=$destrigfancpu$(echo "${element}"|grep -iv "CPU"|sed 's/.*name":"\|","applications.*//g')\\n
    fi # присваиваем переменные если есть данные данного блока.
    keyfancpu=""
....
    ;;
    *RPM*Fan*)
    # Для Кулеров Кроме CPU
    keyfan=$(echo "${element}"|grep -iv "CPU"|sed 's/^"\|","units".*//g'|sed 's/\\/\\\\/g')
    triggerfan="{"${HOSTHOST}":$keyfan"
    #echo $triggerfan
    if [[ "$keyfan" != "" ]]; then
    fantrig=$fantrig"$ilifan$triggerfan.avg(#3)}=0 or\n$triggerfan.avg(#3)}>2500" # Условие: Кулер неработает 0 или обороты выше 2500
    ilifan=' or\n'
    doptrigfan="$triggerfan" # Для общего условия
    # Название Элемента в описание триггера (из каких эл-ов состоит триггер)
    destrigfan=$destrigfan$(echo "${element}"|grep -iv "CPU"|sed 's/.*name":"\|","applications.*//g')\\n
    fi # присваиваем переменные если есть данные данного блока.
    keyfan=""
....
    ;;
    *V*Voltage*)
....
    ;;
    *KB/s*Throughput*)
....
    ;;
esac
done


# Для Температуры CPU
if [[ "$extrtemptrigexpcpu" != "" ]]; then
#echo "${extrtemptrigexpcpu}" # Тестовый вывод формирования триггера
EXTRTEMPTRIGGERCPU="$extrtemptrigexpcpu or\n$doptrigtempcpu.avg(#3)}=0 or\n$doptrigtempcpu.nodata(1h)}=1" # К последнему элементу добавим условие 0 или нет данных более 1 часа
# Формирование триггеров для создания в узлах через API
NAMEEXTREMHIGHTEMPCPU="ExtremHighTemp CPU {HOST.NAME}=({ITEM.VALUE})" # Имя триггера для 70 градусов
prioritextrtempcpu="5" # Важность Черезвычайная
commentsextremcpu="Слишком высокая температура\nПоследнее значение: {ITEM.VALUE} {ITEM.LASTVALUE} ({TIME})\n\nОшибка Если температура 0\nОшибка Если нет данных более 1 часа\n\n\nИспользуемые элементы:\n$destrigtempcpu" # Описание триггерра для 70 градусов
echo -e $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEEXTREMHIGHTEMPCPU}" $prioritextrtempcpu "${EXTRTEMPTRIGGERCPU}" "${commentsextremcpu}" "${namehw}"  "NoPingAgent {HOST.NAME}"
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEEXTREMHIGHTEMPCPU}" $prioritextrtempcpu "${EXTRTEMPTRIGGERCPU}" "${commentsextremcpu}" "${namehw}" "NoPingAgent {HOST.NAME}"
fi
if [[ "$hightemptrigexpcpu" != "" ]]; then
#echo "${hightemptrigexpcpu}" # Тестовый вывод формирования триггера
HIGHTEMPTRIGGERCPU="$hightemptrigexpcpu or\n$doptrigtempcpu.avg(#3)}=0 or\n$doptrigtempcpu.nodata(1h)}=1" # К последнему элементу добавим условие 0 или нет данных более 1 часа
# Формирование триггеров для создания в узлах через API
NAMEHIGHTEMPCPU="HighTemp CPU {HOST.NAME}=({ITEM.VALUE})" # Имя триггера для 60 градусов
priorithightempcpu="4" # Важность высокая
commentshighcpu="Высокая температура\nПоследнее значение: {ITEM.VALUE} {ITEM.LASTVALUE} ({TIME})\n\nОшибка Если температура 0\nОшибка Если нет данных более 1 часа\n\n\nИспользуемые элементы:\n$destrigtempcpu" # Описание триггерра для 60 градусов
echo -e $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEHIGHTEMPCPU}" $priorithightempcpu "${HIGHTEMPTRIGGERCPU}" "${commentshighcpu}" "${namehw}" "NoPingAgent {HOST.NAME}"
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEHIGHTEMPCPU}" $priorithightempcpu "${HIGHTEMPTRIGGERCPU}" "${commentshighcpu}" "${namehw}" "NoPingAgent {HOST.NAME}"
# Зависимость HighTemp CPU {HOST.NAME}=({ITEM.VALUE}) от ExtremHighTemp CPU {HOST.NAME}=({ITEM.VALUE})
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "" "" "" "" "HighTemp CPU {HOST.NAME}=({ITEM.VALUE})" "ExtremHighTemp CPU {HOST.NAME}=({ITEM.VALUE})"
fi

# Для Температуры кроме CPU
if [[ "$extrtemptrigexp" != "" ]]; then
#echo "${extrtemptrigexp}" # Тестовый вывод формирования триггера
EXTRTEMPTRIGGER="$extrtemptrigexp or\n$doptrigtemp.avg(#3)}=0 or\n$doptrigtemp.nodata(1h)}=1" # К последнему элементу добавим условие 0 или нет данных более 1 часа
# Формирование триггеров для создания в узлах через API
NAMEEXTREMHIGHTEMP="ExtremHighTemp {HOST.NAME}=({ITEM.VALUE})" # Имя триггера для 70 градусов
prioritextrtemp="5" # Важность Черезвычайная
commentsextrem="Слишком высокая температура\nПоследнее значение: {ITEM.VALUE} {ITEM.LASTVALUE} ({TIME})\n\nОшибка Если температура 0\nОшибка Если нет данных более 1 часа\n\n\nИспользуемые элементы:\n$destrigtemp" # Описание триггерра для 70 градусов
echo -e $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEEXTREMHIGHTEMP}" $prioritextrtemp "${EXTRTEMPTRIGGER}" "${commentsextrem}" "${namehw}" "NoPingAgent {HOST.NAME}"
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEEXTREMHIGHTEMP}" $prioritextrtemp "${EXTRTEMPTRIGGER}" "${commentsextrem}" "${namehw}" "NoPingAgent {HOST.NAME}"
fi
if [[ "$hightemptrigexp" != "" ]]; then
#echo "${hightemptrigexp}" # Тестовый вывод формирования триггера
HIGHTEMPTRIGGER="$hightemptrigexp or\n$doptrigtemp.avg(#3)}=0 or\n$doptrigtemp.nodata(1h)}=1" # К последнему элементу добавим условие 0 или нет данных более 1 часа
# Формирование триггеров для создания в узлах через API
NAMEHIGHTEMP="HighTemp {HOST.NAME}=({ITEM.VALUE})" # Имя триггера для 60 градусов
priorithightemp="4" # Важность высокая
commentshigh="Высокая температура\nПоследнее значение: {ITEM.VALUE} {ITEM.LASTVALUE} ({TIME})\n\nОшибка Если температура 0\nОшибка Если нет данных более 1 часа\n\n\nИспользуемые элементы:\n$destrigtemp" # Описание триггерра для 60 градусов
echo -e $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEHIGHTEMP}" $priorithightemp "${HIGHTEMPTRIGGER}" "${commentshigh}" "${namehw}" "NoPingAgent {HOST.NAME}"
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEHIGHTEMP}" $priorithightemp "${HIGHTEMPTRIGGER}" "${commentshigh}" "${namehw}" "NoPingAgent {HOST.NAME}"
# Зависимость HighTemp {HOST.NAME}=({ITEM.VALUE}) от ExtremHighTemp {HOST.NAME}=({ITEM.VALUE})
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "" "" "" "" "HighTemp {HOST.NAME}=({ITEM.VALUE})" "ExtremHighTemp {HOST.NAME}=({ITEM.VALUE})"
fi

# Для кулеров CPU
if [[ "$fantrigcpu" != "" ]]; then
#echo "${fantrigcpu}" # Тестовый вывод формирования триггера
FANTRIGGERCPU="$fantrigcpu or\n$doptrigfancpu.nodata(1h)}=1" # К последнему элементу добавим условие нет данных более 1 часа
# Формирование триггеров для создания в узлах через API
NAMEFANCPU="RPM FAN CPU {HOST.NAME}=({ITEM.VALUE})" # Имя триггера для 60 градусов
prioritfancpu="2" # Важность предупреждение
commentsfancpu="Большие Обороты Кулера\nПоследнее значение: {ITEM.VALUE} {ITEM.LASTVALUE} ({TIME})\n\nОшибка Если Обороты 0\nОшибка Если нет данных более 1 часа\n\n\nИспользуемые элементы:\n$destrigfancpu" # Описание триггерра
echo -e $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEFANCPU}" $prioritfancpu "${FANTRIGGERCPU}" "${commentsfancpu}" "${namehw}" "NoPingAgent {HOST.NAME}"
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEFANCPU}" $prioritfancpu "${FANTRIGGERCPU}" "${commentsfancpu}" "${namehw}" "NoPingAgent {HOST.NAME}"
fi

# Для кулеров Кроме CPU
if [[ "$fantrig" != "" ]]; then
#echo "${fantrig}" # Тестовый вывод формирования триггера
FANTRIGGER="$fantrig or\n$doptrigfan.nodata(1h)}=1" # К последнему элементу добавим условие нет данных более 1 часа
# Формирование триггеров для создания в узлах через API
NAMEFAN="RPM FAN {HOST.NAME}=({ITEM.VALUE})" # Имя триггера для 60 градусов
prioritfan="2" # Важность предупреждение
commentsfan="Большие Обороты Кулера\nПоследнее значение: {ITEM.VALUE} {ITEM.LASTVALUE} ({TIME})\n\nОшибка Если Обороты 0\nОшибка Если нет данных более 1 часа\n\n\nИспользуемые элементы:\n$destrigfan" # Описание триггерра
echo -e $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEFAN}" $prioritfan "${FANTRIGGER}" "${commentsfan}" "${namehw}" "NoPingAgent {HOST.NAME}"
bash "${currentpath}"/triggercreatezbxapi.sh $IP "${HOSTHOST}" "${HOSTNAME}" "${NAMEFAN}" $prioritfan "${FANTRIGGER}" "${commentsfan}" "${namehw}" "NoPingAgent {HOST.NAME}"
fi

outapi
