#!/bin/bash

#2022/06/14 v2.3 test
# Автор Мамзиков Артём Андреевич Описание по скрипту https://diyit.ru/viewtopic.php?t=1946

# Входные атрибуты для отправки информации об ошибке
# IP или DNS узла по умолчанию
HOSTCONN=$1
# Имя узла сети
HOSTHOST=$2
# Видимое имя
HOSTNAME=$3

#Входные данные для триггеров:
# Имя
description=$4
# Важность
priority=$5
# Выражение
expression=$6
# Разрешить закрывать вручную
manual_close="1"
# URL
url=""
# Описание
comments=$7
# Активировано
status="0"
# Зависимость для триггера Имя (зависимый триггер)
nametriggerslave=$8
# Триггер для зависимости Имя (от кого зависимость)
nametriggermaster=$9


#***********************************************************************
#Начало пользовательских переменных
#Установите для них соответствующие значения перед выполнением сценария...
zabbixServer='127.0.0.1' # Или localhost 127.0.0.1
zabbixUsername='Admin' # Логин для заббикс
zabbixPassword='zabbix' #Пароль для заббикс
#Конец пользовательских переменных
#***********************************************************************

header='Content-Type:application/json-rpc'
zabbixApiUrl="http://$zabbixServer/zabbix/api_jsonrpc.php"

function exit_with_error() {
  echo '**********************************'
  echo "$errorMessage"
  echo '----------------------------------'
  echo 'Сформированная Команда выполнения'
  echo '----------------------------------'
  echo  curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl
  echo '----------------------------------'
  echo 'Выходные данные'
  echo '----------------------------------'
  echo "$result"
  echo '**********************************'
  zabbix_sender -z $zabbixServer -p 10051 -s "${HOSTCONN}" -k apitriggercreateerror -o "ERROR $errorMessage Команда выполнения: curl --silent --show-error --insecure --header $header --data $json $zabbixApiUrl Результат $result"
}


#------------------------------------------------------
# Аутентификация пользователя. https://www.zabbix.com/documentation/current/ru/manual/api/reference/user/login
#------------------------------------------------------
errorMessage='*ERROR* - Не удается получить токен авторизации Zabbix'
json=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.login\",\"params\":{\"user\": \"$zabbixUsername\",\"password\": \"$zabbixPassword\"},\"id\": 1 }`
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
auth=$(echo "${result}" |sed -e 's|.*result":"||' -e 's/","id.*//g')
check=$(echo "${auth}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&exit 1 ; fi
echo "Вход в систему выполнен успешно - Идентификатор авторизации: $auth"
errorMessage="";json="";result="";check="" # Очистка переменных


function outapi(){
#------------------------------------------------------
# Выход из zabbix https://www.zabbix.com/documentation/current/ru/manual/api/reference/user/logout
#------------------------------------------------------
# Выполнение выхода из API.
errorMessage='*ERROR* - Не удалось выйти из системы'
json=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.logout\",\"params\": [],\"id\": 1, \"auth\": \"$auth\"}`
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
logout=$(echo "${result}" |sed -e 's|.*result":||' -e 's/,"id.*//g')
check=$(echo "${logout}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error; fi
echo 'Успешно вышел из Zabbix' "${logout}"
errorMessage="";json="";result="";check="" # Очистка переменных
exit 1
}


# Запрос информации об авторизовавшемся пользователе
#usinfo=`echo {\"jsonrpc\": \"2.0\",\"method\":\"user.login\",\"params\":{\"user\": \"$zabbixUsername\",\"password\": \"$zabbixPassword\",\"userData\": true},\"id\": 1 }`
#infouser=`curl --silent --show-error --insecure --header $header --data "$usinfo" $zabbixApiUrl`
#echo "${infouser}"


# Зависимость для триггера (зависимый триггер), получаем ID
#------------------------------------------------------
# Получение триггеров в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/get
#------------------------------------------------------
if [[ "$nametriggerslave" != "" ]]; then
errorMessage='*ERROR* - Не удается проверить триггер'
json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.get\",\"params\": {\"selectTriggerDiscovery\": [\"parent_triggerid\"],\"active\": true, \"output\": [\"triggerid\",\"description\",\"priority\",\"status\"], \"expandComment\": \"True\", \"expandDescription\": \"True\", \"expandExpression\": \"True\", \"filter\": {\"host\": \"$HOSTHOST\",\"description\": \"$nametriggerslave\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
# Поиск триггера и получение его ID
triggeridslave=$(echo $result|egrep -i '"triggerid":"[0-9]+"'|sed 's|.*"triggerid":"||'|sed 's/","description.*//g')
# Если триггер создан из прототипа, получаем ID прототипа триггера в узле
prototypetrigidslave=$(echo $result|egrep -i '"parent_triggerid":"[0-9]+"'|sed 's|.*"parent_triggerid":"||'|sed 's/"}.*//g')
#echo "Найденые триггеры (зависимый):" $result
echo "Получаем ID триггера (зависимый):" $triggeridslave
echo "Получаем ID прототипа триггера (зависимый):" $prototypetrigidslave
errorMessage="";json="";result="";check="" # Очистка переменных
fi


# Триггер для зависимости (от кого зависимость), получаем ID
#------------------------------------------------------
# Получение триггеров в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/get
#------------------------------------------------------
if [[ "$nametriggermaster" != "" ]]; then
errorMessage='*ERROR* - Не удается проверить триггер'
json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.get\",\"params\": {\"active\": true, \"output\": [\"triggerid\",\"description\",\"priority\",\"status\"], \"expandComment\": \"True\", \"expandDescription\": \"True\", \"expandExpression\": \"True\", \"filter\": {\"host\": \"$HOSTHOST\",\"description\": \"$nametriggermaster\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
# Поиск триггера и получение его ID
triggeridmaster=$(echo $result|egrep -i '"triggerid":"[0-9]+"'|sed 's|.*triggerid":"||'|sed 's/","description.*//g')
#echo "Найденые триггеры (зависимость от):" $result
echo "Получаем ID триггера (зависимость от):" $triggeridmaster
errorMessage="";json="";result="";check="" # Очистка переменных
fi


# Получение уже существующих зависимостей триггера
#------------------------------------------------------
# Получение триггеров в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/get
#------------------------------------------------------
if [[ "$triggeridslave$nametriggerslave" != "" ]]; then
errorMessage='*ERROR* - Не удается проверить зависимости  триггера'
json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.get\",\"params\": {\"triggerids\": \"$triggeridslave\",\"active\": true,\"selectDependencies\": [\"triggerid_up\"],\"output\": [\"triggerid\",\"description\",\"priority\",\"status\"],\"filter\": {\"host\": \"$HOSTHOST\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
# Поиск триггера и получение его ID
triggerzavid=$(echo $result|egrep -i 'dependencies":\[{"triggerid":"[0-9]+"'|sed 's|.*dependencies":\[{"triggerid":"||'|sed 's|"}\]}\].*||'|sed 's/"},{"triggerid":"/;/g')
#echo -e "Найденые зависимости:" $result
echo -e "Получаем ID триггеров от которых уже есть зависимость:" $triggerzavid
errorMessage="";json="";result="";check="";masstrigupdat="" # Очистка переменных
# Проверка существует уже зависимость или нет, если несколько по очередно через ;
chekzavisimtrig="no" # Изначальное значение переменной нет зависимостей
masstrigupdat="" # Нет массива зависимостей
if [[ "$triggerzavid" != "" ]]; then # Если зависимостей нет пропускаем блок
IFS=';' read -ra razbivkatrigid < <(echo "${triggerzavid}")
for zavtrigid in "${razbivkatrigid[@]}"
do
if [[ ${zavtrigid} == ${triggeridmaster} ]]; then chekzavisimtrig="yes"
echo "Зависимость существует ${zavtrigid} == ${triggeridmaster}"
else
# Если делаем через обновление: Формируем массив Текущие зависимости +(новая для обновления в самом блоке обновления)
masstrigupdat=$masstrigupdat"{\"triggerid\": \"$zavtrigid\"},"
fi
done
fi
fi
echo $chekzavisimtrig "Массив текущих зависимостей:" $masstrigupdat


# Добавляем зависимость
#------------------------------------------------------
# Создавать новые зависимости триггеров https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/adddependencies
#------------------------------------------------------
if [[ "$chekzavisimtrig" == "no" ]]; then # если зависимости нет идем дальше, если есть пропускаем данный блок
if [[ "$nametriggerslave$nametriggermaster" != "" ]]; then # проверяем что переменные не пустые, есть id триггеров для создания зависимостей
errorMessage='*ERROR* - Не удается Создать зависимости триггера $nametriggerslave от $nametriggermaster'
json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.adddependencies\",\"params\": {\"triggerid\": \"$triggeridslave\",\"dependsOnTriggerid\": \"$triggeridmaster\"},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
checkr=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
duplicate=$(echo "${result}"|tr -d '\r\n'|grep -Eci "Duplicate dependencies in trigger") # Проверка на дубль что уже есть зависимость, чтоб не высылало ошибку по дублю
if [[ "$duplicate" == "0" ]]; then


# БЛОК ДЛЯ ПРОТОТИПОВ ТРИГГЕРОВ ---------------------------
# Проверка на прототип триггера, если есть прототип триггера в узле добавляем к нему зависимость (проставится после повторного обнаружения)
prototypetrig=$(echo "${result}"|tr -d '\r\n'|grep -Eci "No permissions to referred object or it does not exist|for a discovered trigger")
if [[ "$prototypetrig" == "1" ]]; then
# Проверяем получен ли ID прототипа триггера, если нет пробуем найти по имени триггера (макросы не раскрываются! при поиске по имени учитывать)
if [[ "$prototypetrigidslave" == "" ]]; then
# Зависимость для прототипа триггера (зависимый прототип триггер), получаем ID
#------------------------------------------------------
# Получение прототипов триггеров в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/triggerprototype/get
#------------------------------------------------------
if [[ "$nametriggerslave" != "" ]]; then
errorMessage='*ERROR* - Не удается проверить прототип триггера $nametriggerslave'
json="{\"jsonrpc\": \"2.0\",\"method\":\"triggerprototype.get\",\"params\": {\"active\": true, \"output\": [\"triggerid\",\"description\",\"priority\",\"status\"],\"filter\": {\"host\": \"$HOSTHOST\",\"description\": \"$nametriggerslave\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
# Поиск прототипа триггера и получение его ID
prototypetrigidslave=$(echo $result|egrep -i '"triggerid":"[0-9]+"'|sed 's|.*triggerid":"||'|sed 's/","description.*//g')
#echo "Найденые прототипы триггеры:" $result
echo "Получаем ID прототипа триггера:" $prototypetrigidslave
errorMessage="";json="";result="";check="" # Очистка переменных
fi
fi

# Получение уже существующих зависимостей прототипа триггера
#------------------------------------------------------
# Получение прототипы триггеров в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/triggerprototype/get
#------------------------------------------------------
if [[ "$prototypetrigidslave" != "" ]]; then
errorMessage='*ERROR* - Не удается проверить зависимости  триггера'
json="{\"jsonrpc\": \"2.0\",\"method\":\"triggerprototype.get\",\"params\": {\"triggerids\": \"$prototypetrigidslave\",\"active\": true,\"selectDependencies\": [\"triggerid_up\"],\"output\": [\"triggerid\",\"description\",\"priority\",\"status\"],\"filter\": {\"host\": \"$HOSTHOST\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
# Поиск прототипа триггера в узле и получение его ID
triggerzavid=$(echo $result|egrep -i 'dependencies":\[{"triggerid":"[0-9]+"'|sed 's|.*dependencies":\[{"triggerid":"||'|sed 's|"}\]}\].*||'|sed 's/"},{"triggerid":"/;/g')
#echo "Найденые зависимости у прототипа в узле:" $result
echo "Получаем ID триггеров от которых уже есть зависимость:" $triggerzavid
errorMessage="";json="";result="";check="" # Очистка переменных
# Проверка существует уже зависимость или нет, если несколько по очередно через ;
chekzavisimtrig="no" # Изначальное значение переменной нет зависимостей
masstrigupdat="" # Нет массива зависимостей
if [[ "$triggerzavid" != "" ]]; then # Если зависимостей нет пропускаем блок
IFS=';' read -ra razbivkatrigid < <(echo "${triggerzavid}")
for zavtrigid in "${razbivkatrigid[@]}"
do
if [[ ${zavtrigid} == ${triggeridmaster} ]]; then chekzavisimtrig="yes"
echo "Прототип Зависимость существует ${zavtrigid} == ${triggeridmaster}"
else
# Если делаем через обновление: Формируем массив Текущие зависимости +(новая для обновления в самом блоке обновления)
masstrigupdat=$masstrigupdat"{\"triggerid\": \"$zavtrigid\"},"
fi
done
fi
echo $chekzavisimtrig "массив уже существующих зависимостей:" $masstrigupdat

if [[ "$chekzavisimtrig" == "no" ]]; then # если зависимости нет идем дальше, если есть пропускаем данный блок
#------------------------------------------------------
# Обновить существующие прототипы триггеров https://www.zabbix.com/documentation/current/ru/manual/api/reference/triggerprototype/update
#------------------------------------------------------
errorMessage='*ERROR* - Не удается Обновление зависимости прототипа триггера $nametriggerslave $prototypetrigidslave от $nametriggermaster $triggeridmaster'
json="{\"jsonrpc\": \"2.0\",\"method\":\"triggerprototype.update\",\"params\": {\"triggerid\": \"$prototypetrigidslave\", \"dependencies\":[$masstrigupdat{\"triggerid\": \"$triggeridmaster\"}]},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
echo "Создание/Обновление зависимости прототипа триггера $nametriggerslave $prototypetrigidslave от $nametriggermaster $triggeridmaster:"
#echo "Сформированая команда:" $json
errorMessage="";json="";result="";check="" # Очистка переменных
fi
errorMessage="";json="";result="";check="";duplicate="" # Очистка переменных
fi # Закрытие 2 попытка получить id прототипа триггера из имени тригера
else
if [[ ${checkr} == *ERROR* ]]; then exit_with_error ; fi # Ошибка, если это не дубль или прототип
fi # Закрытие проверки на прототип триггера
fi # Закрытие еще одной проверки существует уже зависимость или нет
fi # Закрытие проверки id триггеров не пустые
fi # Закрытие проверки существует уже зависимость или нет


# Обновляем данные триггера, добавляем зависимость (если есть зависимость другая она заменяется)
#------------------------------------------------------
# Обновление существующих триггеров https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/update
#------------------------------------------------------
#if [[ "$nametriggerslave$nametriggermaster" != "" ]]; then
#errorMessage='*ERROR* - Не удается Обновление зависимости триггера $nametriggerslave от $nametriggermaster'
#json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.update\",\"params\": {\"triggerid\": \"$triggeridslave\", \"dependencies\":[$masstrigupdat{\"triggerid\": \"$triggeridmaster\"}]},\"auth\":\"$auth\", \"id\": 1 }"
#result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
#check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
#if [[ ${check} == *ERROR* ]]; then exit_with_error ; fi
#echo "Обновление зависимости триггера $nametriggerslave от $nametriggermaster:" $result
#errorMessage="";json="";result="";check="" # Очистка переменных
#fi


# Проверка Перед Созданием существует триггер или нет (по имени), если да выходим
#------------------------------------------------------
# Получение триггеров в соответствии с заданными параметрами https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/get
#------------------------------------------------------
if [[ "$expression" != "" ]]; then
errorMessage='*ERROR* - Не удается проверить триггер'
json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.get\",\"params\": {\"active\": true, \"output\": [\"triggerid\",\"description\",\"priority\",\"status\"],\"filter\": {\"host\": \"$HOSTHOST\",\"description\": \"$description\"}},\"auth\":\"$auth\", \"id\": 1 }"
result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&outapi ; fi
# Поиск триггера
checktriggers=$(echo $result|egrep -i '"triggerid":"[0-9]+"'|sed 's|.*result":||'|sed 's/,"id.*//g'|sed 's|.*description":"||'|sed 's/","priority":"'$priority'.*//g')
echo -e "Найденые триггеры:" $result
#echo "Находим строку по соответствию:" $checktriggers
if [[ "$description" == "$checktriggers" ]]; then echo "Триггер существует:" $checktriggers &&outapi ; fi # Если триггер существует завершаем цикл скрипта
errorMessage="";json="";result="";check="" # Очистка переменных
fi


#------------------------------------------------------
# Создание триггера https://www.zabbix.com/documentation/current/ru/manual/api/reference/trigger/create
#------------------------------------------------------
if [[ "$expression" != "" ]]; then
errorMessage='*ERROR* - Не удается создать триггер'
json="{\"jsonrpc\": \"2.0\",\"method\":\"trigger.create\",\"params\":\
[{\"description\": \"$description\",\
\"expression\": \"$expression\",\
\"priority\": $priority ,\
\"status\": $status ,\
\"manual_close\": $manual_close ,\
\"comments\": \"$comments\",\
\"dependencies\":[{\"triggerid\": \"$triggeridslave\"}]}],\
\"auth\":\"$auth\", \"id\": 1 }"

result=`curl --silent --show-error --insecure --header $header --data "$json" $zabbixApiUrl`
triggerids=$(echo "${result}" |sed -e 's|.*result":{"triggerids":\["||' -e 's/\"]},"id.*//g')
check=$(echo "${result}"|tr -d '\r\n'| sed -n 's/error.*\|Invalid.*/ERROR/Ip')
if [[ ${check} == *ERROR* ]]; then exit_with_error &&outapi ; fi
echo "Создание триггера: $triggeridslaves"
errorMessage="";json="";result="";check="" # Очистка переменных
fi

outapi # Запустим блок Выхода
